package sav.example.javaz;
import sav.z.*;

import java.io.*;
/**
 * Following example imports tabular data about users and owners,
 * then selects equal value of "User" and "Owner" class.
 * Example illustrates simultaneous iterative using of
 * the diverse databases ("Owners", "Users").
 * Equal names ("ann1") of the User and Owner class will be printed.
 */
public class MultiDBDemo {
  public static void main(String arg[]) throws IOException {
    String userData =
      "$base \"Users\";" +
      "$readTable() <" +
        "User  ; Name   ; Resource     \n" +
        "ann1  ; Ann    ; data1, data2 \n" +
        "dan   ; Daniel ; data1, data3 \n" +
      ">;"
    ;
    String ownerData =
      "$base \"Owners\";" +
      "$readTable() <" +
        "Owner  ; Name ; Resource \n" +
        "ann1   ; Ann  ; data1    \n" +
      ">;"
    ;
    Session ss = new Session();
    ss.z(userData); //creates Users database
    ss.z(ownerData); //creates Owners database

    ss.exploreBase("Owners");
    Base bowners = ss.base();
    ss.exploreBase("Users");
    Base busers = ss.base();
    System.out.println("OWNER AND USER");
    for (String owner = bowners.first("Owner"); owner != null; owner = bowners.next("Owner", owner)) {
      if (!busers.has("User", owner))
        continue;
      System.out.println(owner);
    }
    bowners.close();
    busers.close();
  }
}
